
///// 受診者カルテに付属する画像を読込する /////

///////////////////////
///// dragAndDrop /////

var _image;
function setImage(img){
    _image = img;
}
function image(){
    return _image;
}

var _imageName;
function setImageName(name){
    _imageName = name;
}
function imageName(){
    return _imageName;
}

function FileDrop(e, can){
    // el にドロップされた画像を描画
    var file = e.dataTransfer.files[0];
    if (!file) {
        alert('画像ファイルの実体がないのでドロップできません');
        return; // file の実体がないとドロップできない
    }
    
    if(!file.type.match(/image\/\w+/)){
        alert('画像ファイルしか受けつけられません');
        return;
    }
    
    setImageName(file.name);
    
    var img = document.createElement("img");
    var reader = new FileReader(); 
    reader.onload = function(e) {
        img.src = e.target.result;
    }
    setImage(img);
    
    // canvas へ描画
    img.onload = function() {
        var ctx = can.getContext("2d");
        
        // 再描画前に今までのイメージを消去
        ctx.clearRect(0, 0, can.width, can.height);
        
        // 画像を表示するクリッピング領域を設定
        var width = can.width;
        var height = can.height;
        ctx.beginPath();
        ctx.moveTo(0,0);
        ctx.lineTo(width, 0);
        ctx.lineTo(width, height);
        ctx.lineTo(0, height);
        ctx.clip();
        
        //ctx.save();
        
        // 画像の高さが can.height に収まるよう縮尺して表示
        var w = image().width * can.height / image().height;
        ctx.drawImage(image(), 0, 0, w, height);  
        
        //ctx.restore();
    }
    
    reader.readAsDataURL(file);
    
    // 保存ボタンを表示
    var elm = elmFor("saveButtonArea");
    elm.innerHTML = "";
    var bt = newDIV(elm, "/fixButton");
    bt.innerHTML = "保存";
    bt.setAttribute("onclick", "saveImage()");
}

///// dragAndDrop /////
///////////////////////

function file_append(){
	// ファイル選択ボタンを増やす
	var dv = document.getElementById("file");
	var ub = newUploadBUTTON(dv, "", "files[]");
	newBR(dv);
}

function upload(){
    // form を submit
    var submitButton = document.getElementById("uploadForm");
    submitButton.submit();
    
    putWindowSize(); // ウインドー・サイズを記憶
    
    setTimeout(getImages, 3000);
}

function makeImagePane(ul, file){
    // path からイメージを生成し elm へ表示
    // === サムネイルを表示 ========================
    var div = newDIV(ul, "");
    var sp = newSPAN(div, "");
    var path = imagePath();
    var img = makeThumbnail(ul, path, file);
    sp.innerHTML = img;
    var url = path + "/" + file;
    // url = "../NOA_ARCHIVE/03234200/20130527185022_0.png" 形式
    sp.setAttribute("onclick", "open_image('"+url+"')");
    if (pictureExpand())
        sp.setAttribute("class", "thumb-nail"); // マウスがのると画像が拡大
    // カルテに埋め込むためのタグを生成
    //var path = "/NOA_ARCHIVE/"+patientId()+"/";
    var tag = "<IMG:" + url + ">";
    sp.addEventListener("dragstart",
                        function(ev) {
                        var dt = ev.dataTransfer;
                        dt.setData("text/plain", tag);
                        return true;
                        },
                        false);
    
    // === 画像削除アイコンとファイル名を表示 ==========
    var height = thumbNailSize();
    if (height * 1 > 90){
        var dv = newDIV(div, "");
        var sp = newSPAN(dv, "");
        sp.style.paddingLeft = "5px";
    } else { // サムネイルが小さい場合はファイル名を同じ行に表示
        var dv = div;
        var sp = newSPAN(div, "");
        sp.style.paddingLeft = "5px";
    }
    // ファイル名
    var sp = newSPAN(dv, "/listMember");
    //sp.innerHTML = labelOfGallery(file);
    sp.innerHTML = file;
    sp.style.margin = "0 5px";
    sp.style.fontSize = "9pt";
    sp.setAttribute("onclick", "pastePicture(this)");
    
    // イメージを削除ボタン
    var img = newIMAGE(dv, "", "./remove-field.png", "");
    img.setAttribute("onclick", "removeImage('"+path +"','"+file+"')");
    img.style.height = "12px";
    img.style.position = "relative";
    img.style.bottom = "-3px";
}

function showIconsVertical(files){
	// 添付ファイルをサムネールとして縦横表示
	var div = elmFor("thumbNailRow");
	div.innerHTML = "";
    
    var dv = newDIV(div, "");
    dv.style.marginBottom = "8px";
    // 画像拡大チェックボックス
    var sp = newSPAN(dv, "expandCheckBox");
    var cb = newCHECKBOX(sp, "", "画像拡大", pictureExpand());
    cb.setAttribute("onchange", "setPictureExpand(this)");
    setInfoTip("expandCheckBox", "マウスで画像拡大"); // INFO TIP
    // 画像転記の確認チェックボックス
    var sp = newSPAN(dv, "copyCheckBox");
    var cb = newCHECKBOX(sp, "", "転記確認", confirmPictureCopy());
    cb.setAttribute("onchange", "setConfirmPictureCopy(this)");
    setInfoTip("copyCheckBox", "画像転記の際 確認"); // INFO TIP
	
	// image ファイルの配列を生成
    var ul = newUL(div, "");
    ul.style.margin = "0";
    ul.style.paddingLeft = "8px";
	for (num in files){
		var filename = files[num];
		if (filename.charAt(0) == ".") continue;
        
        // image のクリックで別パネルに image 表示
        makeImagePane(ul, filename);
	}
}

function makeUploadPane(){
    // FORM を使って画像をアップロードするペーンを生成
    
    // localStorage に記憶
    setPictureUploadType("1");

    var elm = elmFor("loadTypeButtonArea");
    elm.innerHTML = "";
    var div = newDIV(elm, "/left-side");
    div.style.width = "90%";
    div.style.paddingLeft = "0";
    var sp = newSPAN(div, "/gray-tab");
    sp.innerHTML = "ドラッグ・ドロップ";
    sp.setAttribute("onclick", "makeDropPane()");
    var sp = newSPAN(div, "/white-tab");
    sp.innerHTML = "ファイル・アップロード";
    var div = newDIV(elm, "/right-side");
    div.style.paddingRight = "0";
    
    var elm = elmFor("uploadArea");
    elm.innerHTML = "";
    
    if (patientId()){
        var dv = newDIV(elm, "");
        
        // === FORM を生成 =============================
        var fm = newFORM(dv, "pictServer.php"); // submit で起動される URL
        fm.setAttribute("id", "uploadForm");
        fm.setAttribute("name", "formForUpload"); // submit に必要
        // ### iframe を使うにはここがキモ ###
        fm.setAttribute("target", "iframeElement"); // iframe を指定
        
        // === ファイル選択ボタン ========================
        var dv = newDIV(fm, "file");
        var bt = newUploadBUTTON(dv, "imageFile", "files[]");
        // more FILES
        var dv = newDIV(fm, "");
        dv.style.fontSize = "9pt";
        var a = newA(dv, "ファイルをもうひとつ選択", "#", "");
        a.setAttribute("onclick", "file_append()");
        a.style.fontSize = "9pt";
        
        // === 転送データのコンテナー =====================
        var filename = todayAndTimeId();
        // key
        var fd = newFIELD(fm, "key", "", "", "SAVE_IMAGE");
        fd.setAttribute("NAME", "key"); // form で送られるパラメータ
        fd.setAttribute("type", "hidden");
        // patientId
        var fd = newFIELD(fm, "container", "", "", patientId());
        fd.setAttribute("NAME", "container"); // form で送られるパラメータ
        fd.setAttribute("type", "hidden");
        // imageId
        var fd = newFIELD(fm, "imageId", "", "", filename);
        fd.setAttribute("NAME", "imageId"); // form で送られるパラメータ
        fd.setAttribute("type", "hidden");
        
        // === アップロード・ボタン =======================
        // ### iframe を使うにはここがキモ ###
        // form を見せない形で処理するため submit-button 機能を別に作成
        var dv = newDIV(elm, "");
        dv.style.fontSize = "9pt";
        dv.style.marginBottom = "10px";
        var bt = newDIV(dv, "/whiteButton");
        bt.innerHTML = "画像添付";
        bt.setAttribute("onclick", "upload()");
        
        // === データ戻り先として iframe を作成 ===========
        // ### iframe を使うにはここがキモ ###
        var dv = newDIV(elm, "");
		dv.style.display = "none"; // 表示しない
        var fr = newIFRAME(dv, "iframeElement");
    } else {
        var dv = newDIV(elm, "");
        dv.innerHTML = "カルテを開いてからやり直してください";
        dv.style.color = "#b86125";
        dv.style.fontSize = "9pt";
        dv.style.paddingLeft = "10px";
    }
}

function makeDropPane(){
    // 画像をドロップするペーンを生成

    // localStorage に記憶
    setPictureUploadType("0");
    
    var elm = elmFor("loadTypeButtonArea");
    elm.innerHTML = "";
    var div = newDIV(elm, "/left-side");
    div.style.width = "90%";
    div.style.paddingLeft = "0";
    var sp = newSPAN(div, "/white-tab");
    sp.innerHTML = "ドラッグ・ドロップ";
    var sp = newSPAN(div, "/gray-tab");
    sp.innerHTML = "ファイル・アップロード";
    sp.setAttribute("onclick", "makeUploadPane()");
    var div = newDIV(elm, "/right-side");
    div.style.paddingRight = "0";
    
    var elm = elmFor("uploadArea");
    elm.innerHTML = "";

    if (window.File && window.FileReader && window.FileList && window.Blob) {
        // 画像をドロップするエリア
        var div = newDIV(elm, "/clearfix");
        
        // ### dragAndDrop ################
        var can = newCANVAS(div, "myCanvas", 250, 50, null);
        can.style.backgroundColor = "#eee";
        setCanvas(can);
        
        // 保存ボタン・エリア
        var sp = newSPAN(div, "saveButtonArea");
        sp.style.paddingLeft = "5px";
        sp.style.position = "relative";
        sp.style.bottom = "7px";
        
        can.ondrop=function(e){
            FileDrop(e, can);
            e.preventDefault();
        };
        
        can.ondragover=function(e){
            e.preventDefault();
        };
    } else {
        alert('このブラウザーでは File API のサポートが不十分です');
    }
}

function showUploadPane(){
    // 画像添付画面を表示
    setPaneType(_patientImageType);
    
    // TABS =====================================
    var div = elmFor("tabArea");
    div.innerHTML = "";    
    var dv = newDIV(div, "/left-side");
    dv.style.width = "80%";
    // 画面選択タブ
    var sp = newSPAN(dv, "/white-tab");
    sp.innerHTML = "画像添付";
    var sp = newSPAN(dv, "/gray-tab");
    sp.innerHTML = "図版";
    sp.setAttribute("onclick", "showGalleryPane()");
    var dv = newDIV(div, "/right-side");
    // --- ヘルプ・アイコン
    var im = newIMAGE(dv, "helpB", "./help.png", "?");
    im.setAttribute("onclick", "help()");
    im.style.height = "18px";
    im.style.position = "relative";
    im.style.top = "6px";
    im.setAttribute("class", "expandIcon");
    
    // ===== 画像ファイルをアップロード =========
    var elm = elmFor("contentsArea");
    elm.innerHTML = "";
    elm.style.backgroundColor = "#fff"; // 図版編集モードで黄色になっていることがあるので
    
    var div = newDIV(elm, "loadTypeButtonArea/clearfix");
    div.style.marginTop = "10px";
    
    var div = newDIV(elm, "uploadArea");
    div.style.border = "thin solid #ccc";
    div.style.marginBottom = "8px";
    div.style.padding = "5px 5px 0 5px";
    
    // localStorage に記憶された status でアップロード・ペーンを表示
    if (pictureUploadType())
        makeUploadPane();
    else
        makeDropPane();

    // === サムネイル画像行を生成 ===============
    var div = newDIV(elm, "thumbNailRow");
    // サムネイル画像行を表示
    getImages();
}

