
var _canvas;
function setCanvas(cv){
    _canvas = cv;
}
function canvas(){
    return _canvas;
}

var _patientImageType = 0;
var _galleryType = 1;
var _paneType;
function setPaneType(type){
    _paneType = type;
}
function paneType(){
    // ドラッグ・ドロップかファイル・アップロードかを返す
    return _paneType;
}

/////////////////////////
///// カルテからの継承値 ///

function patientId(){
    return (parent()) ? parent().patientId() : null;
}

function patientName(){
    return (parent()) ? parent().patientKanjiName() : null;
}

///// カルテからの継承値 ///
/////////////////////////

///////////////////////////////////
/// localStorage による処理 /////////

var _largeSize = 250;
var _middleSize = 80;
var _smallSize = 30;

function setThumbnailSize(elm){
    // サムネイル・サイズを変更
    if (elm.value == "大")
        window.localStorage["pictureThumbNailSize"] = _largeSize;
    else if (elm.value == "中")
        window.localStorage["pictureThumbNailSize"] = _middleSize;
    else
        window.localStorage["pictureThumbNailSize"] = _smallSize;
    
    // サムネイルを再表示
    getImages();
    
    // テンプレートを再表示
    showTemplates();
}

var _imagePath;
function setImagePath(path){
    _imagePath = path;
}
function imagePath(){
    // サーバ内で画像の存在するパスを返す
    return _imagePath;
}

function thumbNailSize(){
    // サムネイル・サイズを返す
    var size = window.localStorage["pictureThumbNailSize"];
    return (size) ? size : _middleSize;
}

function thumbNailSizeName(){
    // サムネイル・サイズの名前を返す
    var size = thumbNailSize() * 1;
    switch(size){
        case _largeSize: return "大";
        case _smallSize: return "小";
        default: return "中";
    }
}

function getWindowSize(){
	// Picture tool のウインドー位置とサイズをサーバへリクエスト
    var size = window.localStorage["pictureToolWindowSize"];
    
	// サーバから得られたサイズにウインドーを調整する
	if (size){
		var args = size.split(",");
		var x = args[0] * 1;
		var y = args[1];
		var w = args[2];
		var h = args[3];
		// resize を先にしておかないと元が大きいサイズだった場合 moveTo しよう
		// としてもウインドー境界の制限で移動できない場合がある
		window.resizeTo(w, h);
		window.moveTo(x, y);
        
        //alert("getWindowSize->"+size); //##
	}
}
function putWindowSize(){
	// Picture tool のウインドー位置とサイズをサーバへ記憶
    if (window.name != "tools"){
        // tool area で開いた場合はサイズを記憶しない
        var x = window.screenLeft;
        var y = window.screenTop - 22;
        var w = window.outerWidth;
        var h = window.outerHeight;
        var array = [x, y, w, h];
        window.localStorage["pictureToolWindowSize"] = array.join(",");
        
        showFadeoutInfo("messageArea", "ウィンドー・サイズを記憶しました", 800);
    }
}

function setPictureExpand(elm){
    // Picture へマウス・オーバーで画像拡大するかどうかを記憶
    window.localStorage["pictureExpand"] = (elm.checked) ? "1" : "0";
    
    // マウス・オーバー再設定のため画像を再描画
    getImages();
}
function pictureExpand(){
    var status = window.localStorage["pictureExpand"];
    
    return (status && status * 1) ? 1 : 0;
}

function setConfirmPictureCopy(elm){
    window.localStorage["confirmPictureCopy"] = (elm.checked) ? "1" : "0";
    
    // 再設定のため画像を再描画
    getImages();
}
function confirmPictureCopy(){
    // 画像転記時に確認パネルを表示するかどうかのステータスを返す
    var status = window.localStorage["confirmPictureCopy"];
    return (status) ? status * 1 : 0;
}

/// localStorage による処理 /////////
///////////////////////////////////



///////////////////////////
/// Ajax による処理 /////////

function gotImages(){
	if ((xmlHttpObject.readyState == 4) && (xmlHttpObject.status == 200)){
		var value = xmlHttpObject.responseText;
		//alert("gotImages ===\n"+value);//##
        
		var array = value.split("<SEPARATOR>");
		if (array.length > 1){
            var obj = JSON.parse(array[1]);
            
            setImagePath(obj.path);
            showIconsVertical(obj.files);
        }
		hideMessage("_message");
	} else
		showMessage("_message", "サーバで処理中です ...");
}
function getImages(){
    // 画像ファイルのリストをサーバへリクエスト
	xmlHttpObject = createXMLHttpRequest(gotImages);
	if (xmlHttpObject){
        // encodeURI は '&' をエンコードしてくれないのでこちら側でエンコード
        var div = elmFor("thumbNailRow");
        var sp = newSPAN(div, "");
        sp.innerHTML = "画像を読み込んでいます...";
        sp.style.fontSize = "9pt";
        sp.style.color = "#f00";

        // ### send() に与える文字列:st 全体をエンコードしては駄目 ###
        var st = "key=GET_DIRECTORY";
        st += "&container=" + patientId();
        
        xmlHttpObject.open("POST", "pictServer.php", true);
        xmlHttpObject.setRequestHeader('Content-Type','application/x-www-form-urlencoded; charset=UTF-8');
		//alert("getImages ====\n"+st); //##
        xmlHttpObject.send(st);
	}
}

function removeImage(path, filename){
    // filename を削除
    if (! confirm(filename + "　の画像を削除します")){
        return;
    }
    
	xmlHttpObject = createXMLHttpRequest(gotImages);
	if (xmlHttpObject){
        // encodeURI は '&' をエンコードしてくれないのでこちら側でエンコード
        // ### send() に与える文字列:st 全体をエンコードしては駄目 ###
        var st = "key=REMOVE_IMAGE";
        st += "&container=" + patientId();
        st += "&value=" + path + "/" + filename;
        
        xmlHttpObject.open("POST", "pictServer.php", true);
        xmlHttpObject.setRequestHeader('Content-Type','application/x-www-form-urlencoded; charset=UTF-8');
		//alert("removeImage ====\n"+st); //##
        xmlHttpObject.send(st);
	}
}

function savedTemplates(answer){
    _debug("savedTemplates->"+answer); //##
    
    // 保存ボタンを非表示
    toggleSaveButton(false);
    
    // テンプレートを再表示
    if (paneType() == _patientImageType)
        showTemplates();
    else if (paneType() == _galleryType)
        getGallery();
}
function saveTemplates(){
    // サーバーへギャラリーのインデックス情報を保存
    var array = templates();
    for (num in array){
        var filename = array[num];
        var rec = galleryInfoForName(filename);
        rec.freq = num;
        rec.label = elmFor(filename + ".label").innerHTML;
    }
    _debug("saveTemplates->"+encodeObject(_galleryInfo)); //##
    
    var owner = parent().owner();
    var tag = "PICTURE";
    var item = "GALLERY";
    var value = encodeObject(_galleryInfo);
    NRPutMenu(owner, tag, item, "", value, savedTemplates);
}

function savedImage(answer){
    // 登録された画像を再表示
    var can = canvas();
    var ctx = can.getContext("2d");
    
    // キャンバス上の画像を削除
    ctx.clearRect(0, 0, can.width, can.height);
    
    // 保存ボタンを消す
    elmFor("saveButtonArea").innerHTML = "";
    
    // サムネイル列を再表示
    if (paneType() == _patientImageType){
        getImages();
    } else if (paneType() == _galleryType){
        getGallery();
    }
}
function saveImage(){
    // ドラッグされた画像をサーバへ保存：_patientImageType　_galleryType　両方で使う
    if (! patientId()){
        alert("カルテが特定されていません。対象カルテを検索し氏名などを確認してから画像を取り込んでください");
        return;
    }

    var can = canvas();
    var ctx = can.getContext("2d");
    
    var imageSrc = image().src;
    imageSrc = imageSrc.replace('data:image/png;base64,',''); // 頭の不要部分を削除
    imageSrc = imageSrc.replace('data:image/jpeg;base64,',''); // 頭の不要部分を削除
    
    //_initDebug(true); //##
    _debug("saveImage: imageSrc->"+imageSrc); //##

    var array = imageName().split(".");
    var suffix = (array.length > 1) ? array[array.length - 1] : "?";
    var filename = todayAndTimeId()+"."+suffix;
    
    if (paneType() == _patientImageType)
        NRPutImage(patientId(), "", filename, imageSrc, savedImage);
    else if (paneType() == _galleryType)
        NRPutImage("TEMPLATES", "", filename, imageSrc, savedImage);
}

/// Ajax による処理 /////////
///////////////////////////


function open_image(url){
    // 本文中の Image をクリックした時に呼ばれる
	var win = window.open("imageViewer.php?value=" + url, "ImageViewer"
                          ,"width=1700,height=1700,scrollbars=yes,resizable=yes");
	win.focus();
}

function pastePicture(elm){
    // 画像を所見欄に貼り付ける    
    var filename = elm.innerText;
    if (confirmPictureCopy() > 0){
        if (!confirm(filename + " を所見欄へ貼付しますか")) return;
    }

    var tag = "ProgressSection.object";
    var rec = parent().valueForTag(tag);
    var val = (rec) ? rec.value : "";
    var url = "<IMG:" + imagePath() + "/" + filename + ">";
    
    val = (trim(val).length == 0) ? url : val + url;
    
    // 画像を所見欄へ添付し save
    parent().gotValueFromTool(val, true);
}

function makeThumbnail(ul, path, file){
    // サムネイルを生成して返す
    var url = path + "/" + file;
    var sfx = suffix(file);
    var width = thumbNailSize();
    
    if ((sfx == "pdf") || (sfx == "PDF")){
        var img = "<IMG SRC=pdf.jpg width=" + width + ">";
    } else if (isImageFile(url)){
        var img = "<IMG SRC="+url+" width=" + width + ">";
    } else if (isMovieFile(url)){
        var img = "<IMG SRC=movie.jpg width=" + width + ">";
    } else if (sfx == "zip"){
        var img = "<IMG SRC=zip.png width=" + width + ">";
    } else if (sfx == "txt"){
        var img = "<IMG SRC=text.png width=" + width + ">";
    } else {
        var img = "<IMG SRC=file.png width=" + width + ">";
    }
    return img;
}

function pictureHelp(){
    // ヘルプを開く
	window.open("./pictureHelp.html","Help"
				,"width=450,height=700,scrollbars=yes,resizable=yes");
}
function galleryHelp(){
    // ヘルプを開く
	window.open("./galleryHelp.html","Help"
				,"width=450,height=700,scrollbars=yes,resizable=yes");
}
function help(){
    // ヘルプを開く
    switch (paneType()){
        case _patientImageType: pictureHelp(); break;
        case _galleryType: galleryHelp(); break;
    }
}

function initPicture(){
	// テンプレートで FRONT のヘッダー部分を生成
    //_initDebug(true); //##
    _debug("== initPicture =="); //##
    
	var elm = document.getElementById("base");
	elm.innerHTML = "";

    var div = newDIV(elm, "messageArea");
    div.style.fontSize = "9pt";

    // ===== HEADER ===================
    var div = newDIV(elm, "/tool-header");
    // === LEFT SIDE ===
    var dv = newDIV(div, "/left-side");
	dv.style.position = "/relative";
	dv.style.top = "4px";
	// カルテID・氏名
    var pid = "";
    var name = "";
    if (patientId()){
        pid = patientId();
        name = patientName();
    }
    var sp = newSPAN(dv, "patientIdArea");
    sp.innerHTML = pid;
    sp.style.paddingRight = "5px";
    var sp = newSPAN(dv, "");
    sp.innerHTML = name;
    // === RIGHT SIDE ===
    var dv = newDIV(div, "/right-side");
    // --- サムネイル・サイズ変更
    var sp = newSPAN(dv, "");
    sp.innerHTML = "サムネイル";
    sp.style.fontSize = "9pt";
    sp.style.color = "#888";
    var sp = newSPAN(dv, "");
    sp.style.paddingRIght = "5px";
    var array = ["大","中","小"];
    var pm = newPopupMenu(sp, "", array, thumbNailSizeName());
    pm.setAttribute("onchange", "setThumbnailSize(this)");
    pm.style.position = "relative";
    pm.style.bottom = "2px";
    
    // TABS =====================================
    var div = newDIV(elm, "tabArea/clearfix");
    div.style.backgroundColor = "#aec";

    // CONTENTS =================================
    var div = newDIV(elm, "");
    div.style.backgroundColor = "#aec";
    var dv = newDIV(div, "contentsArea");
    dv.style.backgroundColor = "#fff";
    dv.style.fontSize = "9pt";
    dv.style.borderTop = "thin solid #aaa";
    dv.style.borderLeft = "thin solid #aaa";
    dv.style.borderRight= "thin solid #aaa";
    dv.style.borderRadius = "10px 10px 0 0";
    dv.style.padding = "10px 10px 10px 10px";
    
    // FOOTER ===================================
    var div = newDIV(elm, "/tool-footer");
    div.style.marginTop = "5px";
    // LEFT SIDE ----------------------------
    var dv = newDIV(div, "/left-side");
    dv.style.width = "60%";
    dv.style.fontSize = "9pt";
    // RIGHT SIDE ----------------------------
    var dv = newDIV(div, "/right-side");
    var sp = newSPAN(dv, "/versionArea");
    sp.innerHTML = version();

    getWindowSize();
    
 //   var type = pictureUploadType();
    
    // 画像添付ペーンを表示
    showUploadPane(); 
}

function version(){
	return "Ver.140306";
}


